"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Actions(ProtocolElement):
    """
    Clinical actions
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import reports as reports_6_7_2

        return {
            "diagnostic": reports_6_7_2.Diagnostic,
            "otherAction": reports_6_7_2.OtherAction,
            "prognosis": reports_6_7_2.Prognosis,
            "therapies": reports_6_7_2.Therapy,
            "trials": reports_6_7_2.Trial,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import reports as reports_6_7_2

        return {
            "org.gel.models.report.avro.Diagnostic": reports_6_7_2.Diagnostic,
            "org.gel.models.report.avro.OtherAction": reports_6_7_2.OtherAction,
            "org.gel.models.report.avro.Prognosis": reports_6_7_2.Prognosis,
            "org.gel.models.report.avro.Therapy": reports_6_7_2.Therapy,
            "org.gel.models.report.avro.Trial": reports_6_7_2.Trial,
            "org.gel.models.report.avro.Actions": reports_6_7_2.Actions,
        }

    __slots__ = [
        "diagnostic",
        "otherAction",
        "prognosis",
        "therapies",
        "trials",
    ]

    def __init__(
        self,
        diagnostic=None,
        otherAction=None,
        prognosis=None,
        therapies=None,
        trials=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_7_2.Actions model.

        :param diagnostic:
        :type diagnostic: None | list[Diagnostic]
        :param otherAction:
        :type otherAction: None | list[OtherAction]
        :param prognosis:
        :type prognosis: None | list[Prognosis]
        :param therapies:
        :type therapies: None | list[Therapy]
        :param trials:
        :type trials: None | list[Trial]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.7.2"
